# Webster+ Setup and Configuration

General Configuration |

The Configuration settings for Webster+ are used to define the format and look of a Web site, as well as various internal settings required by the system, such as the Email and SMS servers used to contact users. Many of the settings defined in the Configuration utility are accessible through the %Webster system object.

The Configuration consists of the following eight sections:

Section | Contents
Site Info | General site information, such as name, icon, contact email, etc.
Customizations | Custom CSS and Java Script to be added to all the Web pages on the site.
Template | Template File and colors to use within the system for various standard elements.
Security | Option to enable system security (highly recommended) and Administrator user name, password and email address.
Access Control | (Available when Webster+ Security is enabled) Access control setting used to select which specific group of users is allowed to create/delete files and directories, as well as edit programs and HTML files, through the Webster+ Inspector. (Access Control was added in PxPlus 2021 Update 1.)
Email | System email settings used to send emails to users regarding notifications such as forgotten password or two-step authorization.
SMS | System SMS settings used to send SMS text messages to users.
Misc. | Miscellaneous system settings, such as chart legend location, grid lines settings, query list colors, Wiki documentation, error dumps, etc. (The ability to set options for Wiki documentation was added in PxPlus 2022.)

When this utility first comes up, it will display the Site Info. You can click on the desired section from the tab line on the System Configuration page. This will display the input screen for that section and allow you to edit and save the settings. The Save button will save the entries for all the sections.

## Site Information

Click on Site Info to bring up the Site Information page:

The following settings can be maintained on this page:

Input Label | Description | %Webster Property
Site Name | Name to appear across the top of the screen. It will be included in all site generated emails. Example: | SiteName$
Site Image | Image to be displayed centered in the upper left of the standard site template. If desired, you can change this by clicking or dropping a new file in the region below the input. The image file can be one of the following file types: .js, .css, .png, .mp4 or .gif. Example: | SiteImage$
Site Homepage | URL of the site you want the users to be directed to when they click the Image in the top left corner of the page. This URL will be brought up in a separate tab. | SiteHomePage$
Contact Email | If provided, an email address that can be used to contact the site administrator. If present, a link to generate the email will be provided on the left side bar. | SiteEmail$
Privacy Page | If provided, a page that describes the site privacy rules. If not present, the system will check for the page _privacy in the application or use *webster/page/privacy.html. | SitePrivacy$
Accept Cookies | System will confirm that user will accept persistent cookies before creating any. | CookieQuery
Temporary File Directory | Location for the system to store any temporary files it may need. | TempDirectory$
Force JS/CSS Reload | This option can be set during development to effectively disable the browser caching of JavaScript or CSS files used by the site. This helps ensure that any changes on the server are applied immediately. | ForceLoad

## Customizations

Click on Customizations to bring up the Customization options:

The following settings can be maintained on this page:

Input Label | Description | %Webster Property
Create/update Local Library - Download lib button | Webster+ uses a number of JavaScript and CSS stylesheet files. These are located and maintained in a library directory found on a PVX Plus server. Click the Download lib button to copy these files to your local docroot /lib sub-directory. Any file in this directory can be saved with an _ (underscore), as in _style.css for example, and will override the default files. #### Note: Once the lib directory is initially downloaded, clicking the Download lib button to create the library or to refresh the data will override any changes made to the original files. They will all be restored to their original state, except for the _ (underscore) created user files. | N/A
Create/update Local Editors - Download Editors button | Click this button to download the ED+ program editor and HTML editor to your docroot /lib sub-directory. This allows authorized users to edit programs and HTML files through the Webster+ Inspector. See Viewing Program Files and Viewing HTML Files. (The Download Editors button was added in PxPlus 2021 Update 1.) | N/A
External Library URL Prefix | This is an optional field that contains the URL of all referenced HTML, CSS or JavaScript files used by the application. By default, the Webster+ application's CSS or JavaScript files are located on a PxPlus server. #### Note: If a URL is entered, the application will look for a style sheet in the URL directory rather than use the default PxPlus server /lib or the downloaded library files in the docroot /lib sub-directory. Example: https://www.yourwebsite.com/ | Library$
Custom CSS | At run time, the entered CSS code will be appended to the <style>…</style> element of the <head>...</head> section. Example: Custom CSS - Syntax p { text-align: center; color: red; } Alternatively, the line above can be entered as a single line if you have several elements of CSS to add. p {text-align: center;color: red;} Custom CSS - Run-Time Example of the Source Code | CustomCSS$
CSS File URL | This is an optional field that contains the URL of a CSS file you want included on every Webster+ page. Only the URL is included, not the contents of the URL, so that the page can generally load faster. The URL must include http: or https: at the beginning of the link. Example: http://localhost:8088/custom.css | ExtraCSSFile$
HTML | This can contain any additional HTML code you want added to the end of all HTML pages. This code will always be inserted right before the </body> tag during run time. Example: Most Web pages contain a footer section. This is a great way to have HTML code show on every Web page instead of having to code it at the bottom of every HTML file. | ExtraHTML$
JavaScript File URL | This is an optional field that contains the URL of a JavaScript file you want included in your pages. The URL must include http: or https: at the beginning of the link. This code will always be inserted right before the </body> tag during run time. Example: http://localhost:8088/custom.js | ExtraJSFile$

## Template Definition

Click on Template to bring up the Template definition:

The following settings can be maintained on this page:

Input Label | Description | %Webster Property
Default Template File | This field contains the name of the template file used to create the Webster+ pages. It can be blank, in which case no template will be applied, or it can contain the name of a page to use. If the first character is an asterisk (*), then the system will first check for a file of the same name in your application search rules, replacing the * with a semi-colon. If that is not found, the system will drop the asterisk and look for the file in *webster/pages. Default value is *template.html. | Template$
Header Height | This field defines the height of the header (as indicated by the blue arrow) found in the template file. Default is 50 pixels. If this is set to 0, the header will not appear on the page. | HeaderHeight
Left Edge Width | This field defines the width of the left edge (as indicated by the green arrow) found in the template file. Default is 180 pixels. If this is set to 0, the left edge will not appear on the page. | HeaderWidth
Default Start page | This field defines the system default starting page to be used when a browser connects. Default value is *default, which will come from the *webster/pages/default.html file or _default.html in the application pages directory. (The Default Start page option was added in PxPlus 2023 Update 1.) | DfltStartPage$

Template Colors

The Template Colors values define the various colors used by the standard template/CSS files. You can define the color of the background and, for some sections, the color of the text to appear in that area.

The Reset to Default colors button located near the bottom will reset the colors selected to the system default color set.

Example:

To help clarify each Template Color option and show the type of area it applies to, numbers have been added beside the options and their matching areas in the screenshot.

## System Security

Click on Security to bring up the system security settings.

Webster+ has been modified to allow it to share the user registration files with NOMADS/iNomads. A check box has been added to the Setup Security tab that will enable this option. Once it is enabled, user information will be maintained in Webster+ on the same file as NOMADS uses. The use of User Groups in Webster+ will remain independent of the Security Classes in NOMADS. Two-factor authentication also remains independently controlled; however, the authentication for Webster+ will be shared with iNomads and vice-versa.

The following settings can be maintained on this page:

Input Label | Description | %Webster Property
Security Enabled | Check box that controls whether the system will enable security. | HasSecurity
Use Nomads Security file | Set this option to allow Webster+ to share the user registration files with NOMADS/iNomads. Once it is enabled, user information will be maintained in Webster+ on the same file as NOMADS uses. If NOMADS security is not set up, the NOMADS user registration files will be created with the ADMIN user. (The Use Nomads Security file option was added in PxPlus 2023.) | UseNomadsSecurity
Self-registration Group | Name of the user group that will be assigned to any user that self-registers. If left blank, self-registration is not possible. | SelfRegister$
Password Regular Expression | Regular expression to be used to validate that the password entered matches the Site security requirements. Default is 8 characters with at least one uppercase letter, one lowercase letter, and a digit. | PswdRegExp$
Password Tip | Tip that will be assigned to the system password fields. | PswdTip$
Web Password Duration | This is the number of days that the system will allow the user's password to be preserved on a workstation before forcing the user to reset the password. Default is 30 days. (The Password Duration option was changed to Web Password Duration in PxPlus 2022 Update 1.) | PswdDuration
Desktop Password Duration | This is the number of hours that the password will remain active when running a Webster+ application using the *Webster/Desktop utility. Default is 4 hours. (The Desktop Password Duration option was added in PxPlus 2022 Update 1.) | DesktopPswdHrs
Two-step Verification | This controls whether the system will force two-step verification. Three options are available (internal value shown in parenthesis): • Don't use (N) • Use on new device (Y) • Always use (A) | TwoStepVerify$
Workstation Duration | When using two-step verification, this is the number of days before a workstation will have to be re-validated. | WsDuration
Group if not signed on | If present, this is the Security group that will be assigned for public access. Group specified can be used to define what that user can access beyond the logon prompt. |
Administrative User |
Userid | User name to be used for the system administrator. Default is Admin.
Password | Administrator's password. You can enter a new password and click Save to change the administrator's password.
Email | Administrator's email address.
| AdminUser$ AdminEmail$

## Access Control Setting

(Available when Webster+ Security is enabled)

Click on Access Control to bring up the Inspector Edit Access group setting:

The following setting can be maintained on this page:

Input Label | Description | %Webster Property
Inspector Edit Access | This controls which specific group of users is allowed to create/delete files and directories, as well as make changes using the Edit button when viewing a file's contents through the Webster+ Inspector. Default is the System Administrators group. User groups are defined in Group Maintenance. | EditAccess$

(Access Control was added in PxPlus 2021 Update 1.)

## Email Settings

Click on Email to bring up the system email settings:

The following settings can be maintained on this page:

Input Label | Description | %Webster Property
Email Address | Email address used for all emails sent by the system, such as password reset requests and two-step verifications. | EmailFrom$
SMTP Server | Name of the SMTP server used to send emails. | EmailSmtp$
SMTP Port | Port number that the email server monitors. Some commonly used ports are 25, 465 or 587. | EmailPort
SMTP Account | Account name to use when connecting to the email server, if required. | EmailAcct$
Account Password | Account password for the SMTP account. | EmailPswd$

To setup a test email using these settings, enter an email address and then click the Test button.

## SMS (Text Messaging) Settings

Click on SMS to bring up the text messaging settings:

The following settings can be maintained on this page:

Input Label | Description | %Webster Property
SMS Provider | SMS provider to be used to send any SMS by the system, such as requests for two-step verifications. Values allowed: • smsmatrix • extexting • grouptexting • nexmo • twillio • smsbroadcast | SMSService$
SMS Account | Account name to use when connecting with the SMS provider. | SMSAcct$
SMS Passcode | Account password/passcode. | SMSPasscode$

To setup a test SMS message using these settings, enter a cell phone number and then click the Test button.

## Miscellaneous

Click on Misc to bring up additional system settings:

The following settings can be maintained on this page:

Input Label | Description | %Webster Property
Chart legend location | Defines where the legend should be placed when rendering a chart in Webster+. Possible values are: • Top • Right • Bottom • Left • None | ChartLegendLocation$
Grid lines on Queries and Smart lists | Defines whether you want grid lines enabled by default for Queries and Smart Lists (which use the Query system). Possible values are (internal value shown in parenthesis): • None (n) • Vertical (v) • Horizontal (h) • Both (*) | GridLines$
Use alternating colors in queries | Set this option if you want queries to use alternating colors by default. | QueryAlternating
Wiki Subsystem Enabled | Set this option if you want the system to check for Wiki documentation on the pages in the system. (The Wiki Subsystem Enabled option was added in PxPlus 2022.) | WikiEnabled
Wiki link text | Set this value to the HTML text you want displayed in the top right corner of the page when Wiki documentation is available or can be edited/added to the system. Default is <i>Info</i>. The text will appear blue if the Wiki is present or red if not present but could be added. (The Wiki link text option was added in PxPlus 2022.) | WikiLinkText$
Dynamic Wiki Creation | Set this option if you want the system to dynamically create basic Wiki documentation on the fly for the pages displayed. (The Dynamic Wiki Creation option was added in PxPlus 2022.) | WikiOnTheFly
Google Maps APIKEY | If you are going to use the Webster+ Google Maps interface, you can supply your Google Maps API key to the system so that it does not have be supplied in the form [map] short codes. (The Google Maps APIKEY option was added in PxPlus 2022.) | GoogleMapKey$
Enable MSGBOX directive | This option, when enabled, will allow the application to issue MSGBOX directives for display on the server console. By default, this option is Off and should only be enabled during local development on the Webster+ server. (The Enable MSGBOX directive option was added in PxPlus 2022.) | EnableMSGBOX
File Maint to use Message box | When checked (default), all messages will display in message boxes. If unchecked, all messages will use option boxes. See Webster+ OptionBox method. (The File Maint to use Message box option was added in PxPlus 2023.) | FM_MsgBox
iNomads URL/port | If you are going to use iNomads with Webster+, specify the URL that will be used to launch iNomads. If you will be using the same domain and protocol (HTTP vs. HTTPS) but on a different port, you only need to specify the port number to be used. Webster will automatically determine the domain and protocol to use. #### Note: To support embedded iNomads Webster+ pages, Webster+ and iNomads should be on the same domain and use the same protocol (HTTP vs. HTTPS). This makes it easier to just specify an iNomads port number instead of a URL. See Using iNomads with Webster+. (The iNomads URL/port option was added in PxPlus 2023.) | iNomadsURL$
Save error dumps | Set this option if you want error dumps to be saved in the data/dump directory. This information will be viewable via the Statistics page. (The Save error dumps option was added in PxPlus 2023.) | SaveErrorDumps
Error dump email notification | (Available when Save error dumps check box is selected) Email address to send a notification to when an error dump occurs. Email server information must be set up on the Email tab. See Email Settings. (The Error dump email notification option was added in PxPlus 2023.) | DumpNotificationEmail$
New user email notification | Email address to send a notification to when a new user creates an account. Email server information must be set up on the Email tab. See Email Settings. (The New user email notification option was added in PxPlus 2023.) | NewUserNotificationEmail$

## See Also

Properties